import { __decorate, __param } from 'tslib';
import { Inject, PLATFORM_ID, ɵɵdefineInjectable, ɵɵinject, Injectable } from '@angular/core';
import { isPlatformServer } from '@angular/common';

var Angular2MaterializeV1Service = /** @class */ (function () {
    function Angular2MaterializeV1Service(platformId) {
        this.platformId = platformId;
    }
    Angular2MaterializeV1Service_1 = Angular2MaterializeV1Service;
    Angular2MaterializeV1Service.prototype.autoInit = function () {
        if (isPlatformServer(this.platformId))
            return null;
        return M.AutoInit();
    };
    Angular2MaterializeV1Service.prototype.toast = function (opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.toast(opts);
    };
    Angular2MaterializeV1Service.prototype.dismissAllToasts = function () {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Toast.dismissAll();
    };
    Angular2MaterializeV1Service.prototype.updateTextFields = function () {
        if (isPlatformServer(this.platformId))
            return null;
        return M.updateTextFields();
    };
    Angular2MaterializeV1Service.prototype.initCarousel = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        var instances = M.Carousel.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
        if (Array.isArray(instances)) {
            for (var i = 0; i < instances.length; ++i) {
                this.addAutoScroll(instances[i]);
            }
        }
        else {
            this.addAutoScroll(instances);
        }
        return instances;
    };
    Angular2MaterializeV1Service.prototype.destroyCarousel = function (instances) {
        if (isPlatformServer(this.platformId))
            return null;
        if (Array.isArray(instances)) {
            for (var i = 0; i < instances.length; ++i) {
                Angular2MaterializeV1Service_1.removeAutoScroll(instances[i]);
                instances[i].destroy();
            }
        }
        else {
            Angular2MaterializeV1Service_1.removeAutoScroll(instances);
            instances.destroy();
        }
    };
    Angular2MaterializeV1Service.prototype.addAutoScroll = function (instance) {
        if (!instance.options.autoScroll)
            return;
        instance.autoScrollIntervalId = window.setInterval(function () { instance.next(); }, instance.options.autoScroll);
        instance.el.addEventListener('mouseover', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart, { passive: true });
        instance.el.addEventListener('mouseleave', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd, { passive: true });
        instance.el.addEventListener('touchstart', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart, { passive: true });
        instance.el.addEventListener('touchend', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd, { passive: true });
    };
    Angular2MaterializeV1Service.removeAutoScroll = function (instance) {
        if (instance.autoScrollIntervalId) {
            window.clearInterval(instance.autoScrollIntervalId);
            instance.autoScrollIntervalId = undefined;
        }
        instance.el.removeEventListener('mouseover', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart);
        instance.el.removeEventListener('mouseleave', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd);
        instance.el.removeEventListener('touchstart', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart);
        instance.el.removeEventListener('touchend', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd);
    };
    Angular2MaterializeV1Service.carouselMouseOverTouchStart = function () {
        var instance = M.Carousel.getInstance(this);
        if (!instance)
            return;
        if (instance.autoScrollIntervalId) {
            window.clearInterval(instance.autoScrollIntervalId);
            instance.autoScrollIntervalId = undefined;
        }
    };
    Angular2MaterializeV1Service.carouselMouseOutTouchEnd = function () {
        var instance = M.Carousel.getInstance(this);
        if (!instance)
            return;
        if (!instance.autoScrollIntervalId) {
            instance.autoScrollIntervalId = window.setInterval(function () { instance.next(); }, instance.options.autoScroll);
        }
    };
    Angular2MaterializeV1Service.prototype.initSelect = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.FormSelect.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initDropdown = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Dropdown.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initDatePicker = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Datepicker.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initAutocomplete = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Autocomplete.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initModal = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Modal.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initTooltip = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Tooltip.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initCollapsible = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Collapsible.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initCharacterCount = function (elms) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.CharacterCounter.init(Angular2MaterializeV1Service_1.getElements(elms));
    };
    Angular2MaterializeV1Service.prototype.initPushpin = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        if (!opts)
            opts = {};
        var elements = Angular2MaterializeV1Service_1.getElements(elms);
        if (elements instanceof NodeList && !opts.offset) {
            var ret = [];
            for (var i = 0; i < elements.length; ++i) {
                opts.offset = elements[i].offsetTop;
                ret.push(M.Pushpin.init(elements[i], opts));
            }
            return ret;
        }
        else if (elements instanceof HTMLElement && !opts.offset) {
            opts.offset = elements.offsetTop;
            return M.Pushpin.init(elements, opts);
        }
        else {
            return M.Pushpin.init(elements, opts);
        }
    };
    Angular2MaterializeV1Service.prototype.initMaterialboxed = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Materialbox.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initFloatingActionButton = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.FloatingActionButton.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.prototype.initSlider = function (elms, opts) {
        if (isPlatformServer(this.platformId))
            return null;
        return M.Slider.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    };
    Angular2MaterializeV1Service.getElements = function (elms) {
        if (elms.charAt(0) === '#') {
            elms = elms.replace('#', '');
            return document.getElementById(elms);
        }
        return document.querySelectorAll(elms);
    };
    var Angular2MaterializeV1Service_1;
    Angular2MaterializeV1Service.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] }
    ]; };
    Angular2MaterializeV1Service.ɵprov = ɵɵdefineInjectable({ factory: function Angular2MaterializeV1Service_Factory() { return new Angular2MaterializeV1Service(ɵɵinject(PLATFORM_ID)); }, token: Angular2MaterializeV1Service, providedIn: "root" });
    Angular2MaterializeV1Service = Angular2MaterializeV1Service_1 = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __param(0, Inject(PLATFORM_ID))
    ], Angular2MaterializeV1Service);
    return Angular2MaterializeV1Service;
}());

/*
 * Public API Surface of angular2-materialize-v1
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Angular2MaterializeV1Service };
//# sourceMappingURL=angular2-materialize-v1.js.map
